# Core

## if
**Пример**:
```liin
> if true
    > print "hi!"
> else
    > print "not hi ;("
```
**Аргументы**: [**0**]: bool

**Возвращает**: -

**Описание**: Выполняет следующий за командой блок кода. Если сразу после if идёт else, то при невыполнении условия, выполняется блок, идущий после блока if

## count
**Пример**:
```liin
! i = 1
> count 3
    > print i
    ! i += 1
```
**Аргументы**: [**0**]: int

**Возвращает**: -

**Описание**: Выполняет следующий за командой блок столько раз, сколько указано в первом аргументе

## while
**Пример**:
```liin
> while true
    > print "endless"
```
**Аргументы**: [**0**]: bool

**Возвращает**: -

**Описание**: Обычный цикл while, выполняет следующий за командой блок, пока первый аргумент = истина

## run
**Пример**:
```liin
!> greeting
    > print "hi!"
> run "greeting"
```
**Аргументы**: [**0**]: String

**Возвращает**: -

**Описание**: Выполняет объявленный блок и возвращается на место

## input
**Пример**:
```liin
! inp << input
```
**Аргументы**: -

**Возвращает**: any

**Описание**: Читает строку из консоли или получает следующий элемент из массива ввода (если язык используется в качестве модуля)


# Base

## print
**Пример**:
```liin
> print 1, 2, 3, 4, 5
```
**Аргументы**: [**X**]: any

**Возвращает**: -

**Описание**: Выводит все переданные аргументы через пробел

## liin
**Пример**:
```liin
> liin
```
**Аргументы**: -

**Возвращает**: -

**Описание**: Выводит лого liin и информацию о текущей версии языка

## show_context
**Пример**:
```liin
> show_context
```
**Аргументы**: -

**Возвращает**: -

**Описание**: Выводит весь контекст для выражений и указания для блоков _([начало, конец, отступ изначальный, отступ блока])_


# Files

## file
**Пример**:
```liin
! f << file "text.txt"
```
**Аргументы**: [**0**]: String

**Возвращает**: File

**Описание**: Возвращает объект файла для дальнейшей работой с ним

## file_create
**Пример**:
```liin
> file_create f
```
**Аргументы**: [**0**]: File

**Возвращает**: -

**Описание**: Создаёт указанный файл

## file_copy
**Пример**:
```liin
> file_copy f, "text2.txt"
```
**Аргументы**: [**0**]: File, [**1**]: String

**Возвращает**: File

**Описание**: Создаёт копию указанного файла по указанному пути

## file_write
**Пример**:
```liin
> file_write f, "123"
```
**Аргументы**: [**0**]: File, [**1**]: any

**Возвращает**: -

**Описание**: Записывает указанную строку в указанный файл

## file_writeb
**Пример**:
```liin
. На данный момент с байтами работа не закончена
> file_writeb f, bytes
```
**Аргументы**: [**0**]: File, [**1**]: List<int>

**Возвращает**: -

**Описание**: Записывает указанные байты в указанный файл

## file_read
**Пример**:
```liin
! str << file_read f
```
**Аргументы**: [**0**]: File

**Возвращает**: String

**Описание**: Возвращает всё содержимое указанного файла

## file_readb
**Пример**:
```liin
. На данный момент с байтами работа не закончена
! bytes << file_readb f
```
**Аргументы**: [**0**]: File

**Возвращает**: List<int>

**Описание**: Возвращает всё содержимое указанного файла в виде байтов

## file_append
**Пример**:
```liin
> file_append f, content
```
**Аргументы**: [**0**]: File, [**1**]: any

**Возвращает**: -

**Описание**: Записывает указанную строку в конец указанного файла

## file_exists
**Пример**:
```liin
! e << file_exists f
```
**Аргументы**: [**0**]: File

**Возвращает**: bool

**Описание**: Возвращает true, если указанный файл существует и false, если нет

## file_remove
**Пример**:
```liin
> file_remove f
```
**Аргументы**: [**0**]: File

**Возвращает**: -

**Описание**: Удаляем указанный файл


# Strings

## str
**Пример**:
```liin
! s << str 1+0, 1+1, 1+2, "45"
```
**Аргументы**: [**X**]: any

**Возвращает**: String

**Описание**: Соединяет разные выражения как строку

## str_slice
**Пример**:
```liin
! s << str_slice "123", 0, 1
```
**Аргументы**: [**0**]: String, [**1**]: int, [**2**]: int

**Возвращает**: String

**Описание**: Возвращает часть указанной строки в указанном промежутке

## str_length
**Пример**:
```liin
! l << str_length "Hi!"
```
**Аргументы**: [**0**]: String

**Возвращает**: int

**Описание**: Возвращает длину указанной строки

## str_color_rgb
**Пример**:
```liin
! s << str_color_rgb "red!", 255, 0, 0, true
```
**Аргументы**: [**0**]: String, [**1**]: num, [**2**]: num, [**3**]: num, ?[**4**]: bool

**Возвращает**: String

**Описание**: Взвращает строку с добавленными цветовыми кодам к указанной строке по RGB

## str_color
**Пример**:
```liin
! s << str_color "blue!", 57
```
**Аргументы**: [**0**]: String, [**1**]: int, ?[**2**]: bool

**Возвращает**: String

**Описание**: Взвращает строку с добавленными цветовыми кодам к указанной строке по XTerm

## str_replace_first
**Пример**:
```liin
! s << str_replace_first "111", "1", "3"
```
**Аргументы**: [**0**]: String, [**1**]: String, [**2**]: String

**Возвращает**: String

**Описание**: Возвращает указанную строку с заменённым первым совпадением указанного шаблона на другой указанный шаблон 

## str_replace_all
**Пример**:
```liin
! s << str_replace_all "111", "1", "3"
```
**Аргументы**: [**0**]: String, [**1**]: String, [**2**]: String

**Возвращает**: String

**Описание**: Возвращает указанную строку с заменёнными всеми совпадениями указанного шаблона на другой указанный шаблон 

## str_contains
**Пример**:
```liin
! s << str_contains "123", "5"
```
**Аргументы**: [**0**]: String, [**1**]: String

**Возвращает**: bool

**Описание**: Возвращает true, если в указанной строке есть указанный шаблон и false, если нет

## str_low
**Пример**:
```liin
! s << str_low "HeLlO!"
```
**Аргументы**: [**0**]: String

**Возвращает**: String

**Описание**: Возвращает указанную строку, приведённую к нижнему регистру

## str_up
**Пример**:
```liin
! s << str_up "HeLlO!"
```
**Аргументы**: [**0**]: String

**Возвращает**: String

**Описание**: Возвращает указанную строку, приведённую к верхнему регистру


# Collections

## cl_remove
**Пример**:
```liin
! l = [1,2,3]
> cl_remove l, 1
```
**Аргументы**: [**0**]: List|Map, [**1**]: int

**Возвращает**: -

**Описание**: Удаляет элемент под указанным индексом/с указанным ключём в указанном списке/указанном словаре

## cl_is_empty
**Пример**:
```liin
! l = [1,2,3]
! is << cl_is_empty l
```
**Аргументы**: [**0**]: List|Map

**Возвращает**: bool

**Описание**: Возвращает true, если указанный список/словарь пустой и false, если не пустой

## cl_length
**Пример**:
```liin
! l = [1,2,3]
! len << cl_length l
```
**Аргументы**: [**0**]: List|Map

**Возвращает**: int

**Описание**: Возвращает длину указанного списка/указанного словаря

## cl_place
**Пример**:
```liin
! l = [1,2,3]
> cl_place l, 0, 4
```
**Аргументы**: [**0**]: List|Map, [**1**]: int|any, [**2**]: any

**Возвращает**: -

**Описание**: Вставляет в указанное место в указанном списке/указанном словаре указанное значение

## cl_join
**Пример**:
```liin
! str << cl_join [1,2,3], " "
```
**Аргументы**: [**0**]: List, [**1**]: String

**Возвращает**: String

**Описание**: Возвращает элементы списка, соединённые при помощи указанной строки


# Types

## type_is_string
**Пример**:
```liin
! is << type_is_string 1
```
**Аргументы**: [**0**]: any

**Возвращает**: bool

**Описание**: Возвращает true, если аргумент - строка, и false, если нет

## type_is_num
**Пример**:
```liin
! is << type_is_num 1
```
**Аргументы**: [**0**]: any

**Возвращает**: bool

**Описание**: Возвращает true, если аргумент - число, и false, если нет

## type_is_int
**Пример**:
```liin
! is << type_is_int 1
```
**Аргументы**: [**0**]: any

**Возвращает**: bool

**Описание**: Возвращает true, если аргумент - целое число, и false, если нет

## type_is_bool
**Пример**:
```liin
! is << type_is_bool 1
```
**Аргументы**: [**0**]: any

**Возвращает**: bool

**Описание**: Возвращает true, если аргумент - логическое значение, и false, если нет

## type_is_cl
**Пример**:
```liin
! is << type_is_cl 1
```
**Аргументы**: [**0**]: any

**Возвращает**: bool

**Описание**: Возвращает true, если аргумент - коллекция (список или словарь), и false, если нет

## type_is_list
**Пример**:
```liin
! is << type_is_list 1
```
**Аргументы**: [**0**]: any

**Возвращает**: bool

**Описание**: Возвращает true, если аргумент - список, и false, если нет

## type_is_map
**Пример**:
```liin
! is << type_is_map 1
```
**Аргументы**: [**0**]: any

**Возвращает**: bool

**Описание**: Возвращает true, если аргумент - словарь, и false, если нет

## type_is_file
**Пример**:
```liin
! is << type_is_file 1
```
**Аргументы**: [**0**]: any

**Возвращает**: bool

**Описание**: Возвращает true, если аргумент - файл, и false, если нет

## type_str
**Пример**:
```liin
! t << type_str 1
```
**Аргументы**: [**0**]: any

**Возвращает**: String

**Описание**: Возвращает тип данных аргумента в виде строки